package com.zhongzheng.modules.base.service.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.lang.Validator;
import cn.hutool.core.util.StrUtil;
import com.zhongzheng.common.exception.CustomException;
import com.zhongzheng.common.utils.DateUtils;
import com.zhongzheng.common.utils.ServletUtils;
import com.zhongzheng.modules.base.bo.CertificateAddBo;
import com.zhongzheng.modules.base.bo.CertificateEditBo;
import com.zhongzheng.modules.base.bo.CertificateQueryBo;
import com.zhongzheng.modules.base.domain.ApplyAreas;
import com.zhongzheng.modules.base.domain.Certificate;
import com.zhongzheng.modules.base.mapper.CertificateMapper;
import com.zhongzheng.modules.base.service.ICertificateService;
import com.zhongzheng.modules.base.vo.CertificateVo;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.github.pagehelper.Page;

import java.util.Collection;
import java.util.Collections;
import java.util.List;
import java.util.stream.Collectors;

/**
 * 证书Service业务层处理
 *
 * @author ruoyi
 * @date 2021-10-08
 */
@Service
public class CertificateServiceImpl extends ServiceImpl<CertificateMapper, Certificate> implements ICertificateService {

    @Override
    public CertificateVo queryById(Long id){
        Certificate db = this.baseMapper.selectById(id);
        return BeanUtil.toBean(db, CertificateVo.class);
    }

    @Override
    public List<CertificateVo> queryList(CertificateQueryBo bo) {
        LambdaQueryWrapper<Certificate> lqw = Wrappers.lambdaQuery();
        lqw.like(StrUtil.isNotBlank(bo.getCertificateName()), Certificate::getCertificateName, bo.getCertificateName());
        lqw.in(bo.getStatus() != null, Certificate::getStatus, bo.getStatus());
        lqw.eq(StrUtil.isNotBlank(bo.getCode()), Certificate::getCode, bo.getCode());
        return entity2Vo(this.list(lqw));
    }

    /**
    * 实体类转化成视图对象
    *
    * @param collection 实体类集合
    * @return
    */
    private List<CertificateVo> entity2Vo(Collection<Certificate> collection) {
        List<CertificateVo> voList = collection.stream()
                .map(any -> BeanUtil.toBean(any, CertificateVo.class))
                .collect(Collectors.toList());
        if (collection instanceof Page) {
            Page<Certificate> page = (Page<Certificate>)collection;
            Page<CertificateVo> pageVo = new Page<>();
            BeanUtil.copyProperties(page,pageVo);
            pageVo.addAll(voList);
            voList = pageVo;
        }
        return voList;
    }

    @Override
    public Boolean insertByAddBo(CertificateAddBo bo) {
        Certificate add = BeanUtil.toBean(bo, Certificate.class);
        add.setCode(ServletUtils.getEncoded("ZS"));
        validEntityBeforeSave(add);
        add.setCreateTime(DateUtils.getNowTime());
        add.setUpdateTime(DateUtils.getNowTime());
        return this.save(add);
    }

    @Override
    public Boolean updateByEditBo(CertificateEditBo bo) {
        Certificate update = BeanUtil.toBean(bo, Certificate.class);
        validEntityBeforeSave(update);
        update.setUpdateTime(DateUtils.getNowTime());
        return this.updateById(update);
    }

    /**
     * 保存前的数据校验
     *
     * @param entity 实体类数据
     */
    private void validEntityBeforeSave(Certificate entity){
        //TODO 做一些数据校验,如唯一约束
        if(checkNameUnique(entity)&&Validator.isEmpty(entity.getId())){
            throw new CustomException("名称重复");
        }
    }

    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return this.removeByIds(ids);
    }

    private boolean checkNameUnique(Certificate entity) {
        Certificate info = getOne(new LambdaQueryWrapper<Certificate>()
                .eq(Certificate::getCertificateName,entity.getCertificateName())
                .last("limit 1"));
        if (Validator.isNotNull(info)) {
            return true;
        }
        return false;
    }
}
